// Programming techniques
//
// Lecture 4 - Sorting & searching
// Example 3 - Binary Search
// -------------------------

#include <iostream>
#include <fstream>
#include <iomanip>
using namespace std;

//  Data input (lengths)
int inp_len(double a[])
{
    int n=0;
    // Define input stream
    ifstream segm("sortlen.txt", ios::in);
    if (! segm) {                               // Check validity of stream
        cerr<<"\n* Error opening input file *\n";
        exit (1); }
    else {                                      // Stream OK, proceed with input
        do {
            segm>>a[n];
            n++; }          
        while (a[n-1]>0);                       // Read until negative marker
        n=n-2;
        segm.close();                           // Disconnect & close file
        }                       
    return n;    
}             

// Binary search of array
// ----------------------
int relax_binsearch(const double arr[], int N, double key)
{
    int mid;
    int k=-1;
    bool succ=false;
    int left=0;
    int right=N;
    while (left<=right && !succ) {
        mid=(left+right)/2;
        if (arr[mid]==key) {
            k=mid;
            succ=true; }
        else if (arr[mid]>key)
            right=mid-1;
        else
            left=mid+1;
    }
    if (succ==true) return k;   
    else return left;
}   

int main()
{
    int n, id1=0, id2=0;
    double s[100], smin, smax, a, b; 
       
    n=inp_len(s);
    smin=s[0];
    smax=s[n];
    cout<<"\nDefine search interval between "<<smin<<" and "<<smax<<endl;
    cout<<"\nEnter lower limit ;";
    cin>>a;
    cout<<"\nEnter upper limit ;";
    cin>>b;    
    id1=relax_binsearch(s,n,a);
    id2=relax_binsearch(s,n,b)-1;   
    n=id2-id1+1;      
    cout<<endl<<n<<" segments have suitable lengths:\n";
    cout<<fixed<<setprecision(4)<<endl;
    for (int k=id1;k<=id2;k++)
        cout<<setw(12)<<s[k]<<endl;
    cout<<endl;    
    system("pause");
    return 0;
}

